/* 
 * File:   Game.h
 * Author: mvdr
 *
 * Created on March 19, 2013, 3:01 PM
 */

#ifndef GAME_H
#define GAME_H

#include "Model.h"
#include "Question.h"
#include <vector>

class Game {
    
    Model d_model;    
    Questions d_questions;
    std::vector<int> d_questionStack;
    std::vector<int> d_kooiStack;
    std::vector<int> d_stateStack;
    int d_currState;
    int d_stateCounter;
    size_t d_currPlayer;
    bool d_magic;
    bool d_verbose;
    bool d_infinite;
    bool d_kooi;
    std::vector<std::set<int> > d_cutOffStates;
    bool d_fullCheck;
    size_t d_skipRounds;
    std::vector<int> d_infGain;
    std::vector<int> d_infGainFull;
    bool d_countInfGain;
    
    
public:
    Game(bool magic, bool infinite, bool kooi, bool full, bool verbose, bool count);
    std::vector<size_t> run();
    int nStates();
    
private:
    void shuffleQuestions();
    std::vector<size_t> startPlaying();
    void updateModel(bool ans, int currQuestion);
    bool anybodyKnows() const;
    size_t numberOfWinners() const;
    bool epistemagic();
    void printInfo() const;
    int minInfQuestion();
    void removeQuestion(int q);
    int informationGain(int q, bool full = false);
    void endGamePrint(int turn);
    
    void because(std::vector<int> const &players);
    std::vector<size_t> returnVector(size_t turn) const;
};

inline int Game::nStates() {
    return d_model.numberOfStates();
}

#endif	/* GAME_H */

